/**
 * Load jquery init
 */
var play_ground = '', rows = 10, cols = 10, icon_no = 6;
var match_mode = 1, total_players = 2, computer = '', own_player_caption = 'You', com_player_caption = 'Computer', player_name = new Array();
var dice_val = 1, rolling_status = 0, moving_status = 0, sl = new Array();

/**
 * snake and ladder position setup
 */
sl[4] = 56; sl[12] = 50; sl[22] = 58; sl[34] = 66; sl[41] = 79; sl[54] = 88; sl[65] = 97;
sl[18] = 1; sl[27] = 8; sl[49] = 36; sl[53] = 11; sl[63] = 25; sl[90] = 72; sl[93] = 21; sl[98] = 86;

/**
 * Device ready with admob ads
 */
var admob = '';
function onDeviceReady() {    
    admob.initAdmob("ca-app-pub-1210545603776368/9731346538","ca-app-pub-1210545603776368/3684812936");
    admob.showBanner(admob.BannerSize.BANNER, admob.Position.BOTTOM_APP);

    document.addEventListener(admob.Event.onInterstitialReceive, onInterstitialReceive, false);//show in ad receive event fun need add receive listener
    admob.cacheInterstitial();// load admob Interstitial
} 

function onInterstitialReceive(message) {//show in ad receive event fun
    admob.showInterstitial();
}

function onGameOver(){//call this fun to show when game over    
    admob.isInterstitialReady(function(isReady){
        if(isReady){
            admob.showInterstitial();
        }
    });
}

/**
 * dice surf for rolling
 */
function dice_rolling(){    
    return Math.floor((Math.random()*6) + 1);
}

/**
 * Initialize player setup
 */
function init_setup(){
    var players_list = ''; moving_status = 0, rolling_status = 0;
    computer = Math.floor((Math.random()*2) + 1);    

    for(i=1;i<=total_players;i++){
        play_ground = play_ground + '<span class="player player-'+ i + (i==1?' active':'') +'" player-no="'+ i +'" cur-rows="0" cur-pos="1" move-data="1" ladder-ride="0" snake-bit="0" cur-standing="0">'+ i +'</span>';
        players_list = players_list + '<div class="cur-players player-list-'+ i + (i==1?' active':'') +'"><i class="fa fa-circle"></i> ' + (computer==i?com_player_caption:(match_mode==1?own_player_caption:'Player '+ i)) +'</div>';
    }
    
    //$('.dice').text('1');
    $('.dice').css('background-image','url(img/dice/die-'+ dice_val +'.gif)');
    $('.play_ground').html(play_ground);
    $('.players_list').html(players_list);
    
    var board_height = $('.snake_ladder_board > img').height();
    //alert(board_height);
    $('.play_ground .ground-rows span').css('height',(Math.floor(board_height/rows)) + 'px');

    //var ground_box_width = $('#room-1').innerWidth();
    //var ground_box_height = $('#room-1').innerHeight();
    //var player_size = Math.floor(ground_box_width/2) - 2;
    //var player_pos = Math.floor((ground_box_width-player_size)/2);

    var board_per_box_width = Math.floor($('.snake_ladder_board img').width()/rows);
    var board_per_box_height = Math.floor($('.snake_ladder_board img').height()/cols);

    var player_size = Math.floor(board_per_box_width/2) - 2;
    var player_pos = Math.floor((board_per_box_width-player_size)/2);
    
    //alert(board_per_box_width+'/'+board_per_box_height+'/'+player_size+'/'+player_pos);

    //alert(ground_box_width+'/'+ground_box_height+'/'+player_size+'/'+player_pos);

    $('.play_ground .player').css({'width': player_size + 'px','height': player_size + 'px','left': (player_pos + 1) + 'px','bottom': (board_per_box_width%2!=0? player_pos - Math.floor(player_pos/2) : player_pos) + 'px'})

    if(computer==1){
        var computerInterval = setInterval(function(){
            dice_surf($('.dice'));
            clearInterval(computerInterval);
        },1000*1);
    }
}

/**
 * Dice surf
 */
function dice_surf(elm){
	rolling_status = 1;
    dice_val = dice_rolling();

    $('.sound_effect_block #dice_roll')[0].play();

    //$(elm).text(dice_val);
    var dice_img = new Array();
    for(i=Math.floor((Math.random()*6) + 1);i<=6;i++){
    	dice_img.push('die-' + i + '.gif');//,'dices-' + i + '.gif','dicet-' + i + '.gif');
    }
    var total_dice_img = dice_img.length;
    //alert(total_dice_img);
        
    var i=0, dicet_random_interval = setInterval(function(){
    	
    	//$(elm).css('background-image','url(img/dice/dicet-'+ i +'.gif)');
    	$(elm).css('background-image','url(img/dice/'+ dice_img[i] +')');
    	i = i + 1;
    	
    	if(i>total_dice_img){
    		$(elm).css('background-image','url(img/dice/die-'+ dice_val +'.gif)');
    		call_player(dice_val);
    		rolling_status = 0; $('.msg').fadeOut();//.html('');
    		clearInterval(dicet_random_interval);
    	}
    },500*1);
	
}

/**
 * Position update
 */
function position_update(player,updt_pos,dice_val,change_type){
    var posUpdateInterval = setInterval(function(){
        var player_total_move = parseInt($('.player-' + player).attr('move-data'));
        var get_unit_width = $('#room-' + updt_pos).innerWidth();
        var get_unit_height = $('#room-' + updt_pos).innerHeight();  
        var player_pos = $('#room-' + updt_pos).position();
        var player_left_pos = player_pos.left;
        var player_top_pos = player_pos.top;
        var row_pos = Math.floor(updt_pos/cols);
        var col_pos = Math.floor(updt_pos%cols);

        $('.player-' + player).attr('cur-pos', updt_pos);
        $('.player-' + player).attr('move-data', player_total_move + 1);

        if(updt_pos<cols){            
            player_left_pos = (updt_pos -(row_pos*cols) - 1) * get_unit_width;            
        }else if(updt_pos%cols==0){            
            row_pos = row_pos - 1;
            player_left_pos = (updt_pos -(row_pos*cols) - 1) * get_unit_width;
        }else{            
            if(row_pos%2==0) player_left_pos = (updt_pos -(row_pos*cols) - 1) * get_unit_width;
            else player_left_pos = (cols - (updt_pos -(row_pos*cols))) * get_unit_width;
        }

        //alert(row_pos + '/' + updt_pos + '/' + player_left_pos);
        
        //$('.player-' + player).css('transform', 'translate('+ (player_left_pos+2) + 'px,-'+ (row_pos*get_unit_height+row_pos) + 'px)');
        $('.player-' + player).css('transform', 'translate('+ player_left_pos + 'px,-'+ (row_pos*get_unit_height) + 'px)');

        $('.player-' + player).attr('cur-rows',row_pos);
        $('.player-' + player).attr('cur-standing',player_left_pos);
        
        if(change_type==1) $('.sound_effect_block #snake_bits')[0].play();
        else $('.sound_effect_block #ladder_ride')[0].play();
        
        call_next_player(dice_val,player);

        clearInterval(posUpdateInterval);

    },500*1)        
}

/**
 * Change players position after surfing data
 */
function change_player_position(player,dice_val){
    var dice_animate_interval = '', game_over_msg = '';
    var get_unit_width = $('.ground-rows > span').innerWidth();
    var get_unit_height = $('.ground-rows > span').innerHeight();
    var player_pos = $('.player-' + player).position();
    var player_left_pos = player_pos.left;
    var player_top_pos = player_pos.top;
    //alert(get_unit_width + '/' + get_unit_height + '/' + player_top_pos + '/' + dice_val);
    var i=1; var player_cur_pos = parseInt($('.player-' + player).attr('cur-pos'));
    if(player_cur_pos + dice_val <= rows*cols){
        moving_status = 1;
        var dice_animate_interval = setInterval(function(){
            var player_total_move = parseInt($('.player-' + player).attr('move-data'));
            
            var total_ladder_ride = parseInt($('.player-' + player).attr('ladder-ride'));
            var total_snake_bit = parseInt($('.player-' + player).attr('snake-bit'));

            var cur_standing = parseInt($('.player-' + player).attr('cur-standing'));

            var cur_row_pos = $('.player-' + player).attr('cur-rows');
            var row_pos = Math.floor(player_cur_pos/cols);
            var col_pos = Math.floor(player_cur_pos%cols);

            //var top = $('.player-' + player).position().top - $('.player-' + player).innerHeight() / 2;
            //var left = $('.player-' + player).position().left - $('.player-' + player).innerWidth() / 2;
            //alert(top + '/' + left);

            //alert((cols - ((player_cur_pos+1) - (row_pos*cols))));
            //alert(row_pos);
            if(row_pos>0 && row_pos!=cur_row_pos){
                //alert(player_left_pos);
                $('.player-' + player).attr('cur-rows',row_pos);
                player_left_pos = cur_standing;
                player_top_pos = (player_top_pos - get_unit_height);// - 1;
                //$('.player-' + player).css('top', player_top_pos + 'px');
                
            }/*else if(row_pos%2==1){
                player_left_pos = (player_left_pos - get_unit_width);// - 1;
                player_top_pos = (player_top_pos - get_unit_height);

                //alert(player_left_pos);
                //$('.player-' + player).css('left', player_left_pos + 'px');
            }else{
                player_left_pos = (player_left_pos + get_unit_width);// + 1;
                player_top_pos = (player_top_pos - get_unit_height);
                //$('.player-' + player).css('left', player_left_pos + 'px');
            }*/            

            else if(row_pos%2==1) player_left_pos = (cols - ((player_cur_pos+1) - (row_pos*cols))) * get_unit_width;
            else player_left_pos = col_pos * get_unit_width;

            //alert((player_left_pos+1)+ '/' + (row_pos*get_unit_height+row_pos));

            //$('.player-' + player).css('transform', 'translate('+ (player_left_pos+1) + 'px,-' + (row_pos*get_unit_height+row_pos) + 'px)');
            $('.player-' + player).css('transform', 'translate('+ player_left_pos + 'px,-' + (row_pos*get_unit_height) + 'px)');

            $('.player-' + player).attr('cur-pos',player_cur_pos + 1);
            $('.player-' + player).attr('move-data',player_total_move + 1);
            $('.player-' + player).attr('cur-standing',player_left_pos);

            $('.sound_effect_block #player_move')[0].play();

            player_cur_pos = parseInt($('.player-' + player).attr('cur-pos'));            

            i = i + 1;
            if(i>dice_val){                
                if(player_cur_pos==rows*cols){
                    //game_over_msg = game_over_msg + '<h1>Game Over</h1>';
                    game_over_msg = game_over_msg + '<h4>'+ (computer==player?'OH! You have lost!':'Congrats! '+ (match_mode==1?own_player_caption + ' have ':'Player ' + player + ' has ') + 'won!') +'</h4>';

                    //game_over_msg = game_over_msg + '<div align="right"><span class="restart">Restart</span></div>';
                    game_over_msg = game_over_msg + '<table class="table table-bordered">';

                    // Table header setup
                    game_over_msg = game_over_msg + '<thead><tr><th></th><th>Moves</th><th>Snake Bites</th><th>Ladder Jump</th></tr></thead>';
                    game_over_msg = game_over_msg + '<tbody>';
                    for(g=1;g<=total_players;g++){
                        var player_name = (computer==g?'Computer':(match_mode==1?own_player_caption:(player_name[g-1]!=''?player_name[g-1]:'Player '+g)));
                        var total_moves = $('.player-'+g).attr('move-data');
                        var total_bites = $('.player-'+g).attr('snake-bit');
                        var total_jump = $('.player-'+g).attr('ladder-ride');
                        game_over_msg = game_over_msg + '<tr><th>'+ player_name +'</th><td>'+ total_moves +'</td><td>'+ total_bites +'</td><td>'+ total_jump +'</td></tr>';
                    }
                    game_over_msg = game_over_msg + '</tbody>';
                    game_over_msg = game_over_msg + '</table>';

                    //game_over_msg = game_over_msg + '<h3></h3>';
                    //$('.msg_overlay').html(game_over_msg);
                    //$('.black_overlay,.msg_overlay').fadeIn();
                    $('#resultModal .modal-body').html(game_over_msg);
                    $('#resultModal').modal({
                        backdrop: 'static',
                        keyboard: true, 
                        show: true
                    });
                }else if(sl[player_cur_pos]!=null){
                    var updt_pos = sl[player_cur_pos];
                    var change_type = 0;
                    if(player_cur_pos<updt_pos) $('.player-' + player).attr('ladder-ride',total_ladder_ride + 1);
                    else if(player_cur_pos>updt_pos){
                        $('.player-' + player).attr('snake-bit',total_snake_bit + 1);
                        change_type = 1;
                    }

                    position_update(player,updt_pos,dice_val,change_type);

                }else call_next_player(dice_val,player);

                clearInterval(dice_animate_interval);
            }
        },600*1);
    }else{
        call_next_player(dice_val,player);
        clearInterval(dice_animate_interval);
    }    
}

/**
 *
 */
function call_next_player(dice_val,player){
    var cur_player_pos = parseInt($('.player-' + player).attr('cur-pos'));
    var next_player_interval = setInterval(function(){    	
        moving_status = 0;
    	$('.msg').fadeOut();//.html('');

        if(dice_val == icon_no && (cur_player_pos + icon_no)<=rows*cols) $('.msg').html('ROLL AGAIN !!!').fadeIn();
        
        //alert(dice_val + '!=' + icon_no + '||' + (cur_player_pos + icon_no) + '>=' + rows*cols);
        //alert(computer + '=' + player);

        if(dice_val != icon_no || (cur_player_pos + icon_no)>=rows*cols){
            var next_player = player + 1;
            if(next_player>total_players) next_player = 1;
            
            $('.player,.cur-players').removeClass('active');
            $('.player-'+ next_player +',.player-list-'+ next_player).addClass('active');

            if(computer==next_player) dice_surf($('.dice'));
                   
        }else if(computer==player) dice_surf($('.dice'));
        
        clearInterval(next_player_interval);
    },1000*1); 
}

/**
 * Players position movement
 */
function call_player(dice_val){
    var player_no = parseInt($('.player.active').attr('player-no'));
    change_player_position(player_no,dice_val);
}

/**
 * Exit application
 */
function exit_app(){    
    navigator.notification.confirm(
        "Do you want to exit the game?",
        function (button) {
          if (button==2) {
            navigator.app.exitApp();
          }
        }
        ,
        "CONFIRMATION",
        ["Cancel","OK"]
    );
}

/**
 * Document Ready
 */
$(document).ready(function() {
    play_ground = '';
    for(var i=rows-1;i>=0;i--){
        play_ground = play_ground + '<div class="ground-rows">';
        if(i%2==1){
            for(j=cols;j>=1;j--){
                play_ground = play_ground + '<span id="room-'+ (i*cols+j) +'">' + (i*cols+j) + '</span>';
            }
        }else{
            for(var j=1;j<=cols;j++){
                play_ground = play_ground + '<span id="room-'+ (i*rows+j) +'">' + (i*rows+j) + '</span>';
            }
        }
        play_ground = play_ground + '</div>';
    }


    /**
     * dice surf
     */    
    $('.dice').on('click', function(){
    	//alert(moving_status);
        if(moving_status==0 && rolling_status==0) dice_surf($(this));
        else if(moving_status==1){
        	$('.msg').html('<i class="fa fa-exclamation"></i> Moving. Wait...').fadeIn();
        }else if(rolling_status==1){
        	$('.msg').html('<i class="fa fa-exclamation"></i> Rolling. Wait...').fadeIn();
        }
    });

    /**
     * Actions
     */
    $('#single_player').on('click', function(){
        $('.front_page').hide();

        /**
         * Initialize player setup
         */
        init_setup();
    });

    /**
     * Help Actions
     */
    $('#help').on('click', function(){
        $('#helpModal').modal('show');
    });

    /**
     * Return home page
     */
    $('.return_home').on('click', function(){
        $('.front_page').show();        
    });

    /**
     * Restart match
     */
    $('.restart').on('click', function(){        
        $('#resultModal').modal('hide');
        init_setup();
    });

    /**
     * Exit application
     */
    $('#exit').on('click', function(){
        exit_app();
    });
});